diff --git a/src/V3DfgSynthesize.cpp b/src/V3DfgSynthesize.cpp
index e36a4e91e30..16d3badadd9 100644
--- a/src/V3DfgSynthesize.cpp
+++ b/src/V3DfgSynthesize.cpp
@@ -39,7 +39,7 @@ namespace {
 // automatically. For the few special cases, we provide specializations below
 template <typename T_Vertex, typename T_Node>
 T_Vertex* makeVertex(const T_Node* nodep, DfgGraph& dfg) {
-    return new T_Vertex{dfg, nodep->fileline(), DfgGraph::toDfgDType(nodep->dtypep())};
+    return new T_Vertex{dfg, nodep->fileline(), V3Dfg::toDfgDType(nodep->dtypep())};
 }
 
 template <>
@@ -48,7 +48,7 @@ DfgArraySel* makeVertex<DfgArraySel, AstArraySel>(const AstArraySel* nodep, DfgG
     // See t_bitsel_wire_array_bad
     if (VN_IS(nodep->fromp(), Const)) return nullptr;
     if (!VN_IS(nodep->fromp()->dtypep()->skipRefp(), UnpackArrayDType)) return nullptr;
-    return new DfgArraySel{dfg, nodep->fileline(), DfgGraph::toDfgDType(nodep->dtypep())};
+    return new DfgArraySel{dfg, nodep->fileline(), V3Dfg::toDfgDType(nodep->dtypep())};
 }
 
 }  // namespace
@@ -77,6 +77,8 @@ class AstToDfgConverter final : public VNVisitor {
     bool m_foundUnhandled = false;  // Found node not implemented as DFG or not implemented 'visit'
     bool m_converting = false;  // We are trying to convert some logic at the moment
 
+    size_t m_nUnpack = 0;  // Sequence numbers for temporaries
+
     // METHODS
     static Variable* getTarget(const AstVarRef* refp) {
         // TODO: remove the useless reinterpret_casts when C++17 'if constexpr' actually works
@@ -107,7 +109,7 @@ class AstToDfgConverter final : public VNVisitor {
                 ++m_ctx.m_conv.nonRepImpure;
             }
             // Check node has supported dtype
-            if (!DfgGraph::isSupported(nodep->dtypep())) {
+            if (!V3Dfg::isSupported(nodep->dtypep())) {
                 m_foundUnhandled = true;
                 ++m_ctx.m_conv.nonRepDType;
             }
@@ -119,7 +121,7 @@ class AstToDfgConverter final : public VNVisitor {
         // Cannot represent cross module references
         if (nodep->classOrPackagep()) return false;
         // Check target
-        return DfgGraph::isSupported(getTarget(nodep));
+        return V3Dfg::isSupported(getTarget(nodep));
     }
 
     // Given an RValue expression, return the equivalent Vertex, or nullptr if not representable.
@@ -163,7 +165,7 @@ class AstToDfgConverter final : public VNVisitor {
                 }
 
                 // Create new one
-                DfgVertexVar* const newp = createTmp(m_dfg, *m_logicp, tgtp, "SynthAssign");
+                DfgVertexVar* const newp = createTmp(*m_logicp, tgtp, "SynthAssign");
                 m_updatesp->emplace_back(tgtp, newp);
 
                 // Create the Splice driver for the new temporary
@@ -223,16 +225,16 @@ class AstToDfgConverter final : public VNVisitor {
             // Ensure the Splice driver exists for this element
             if (!splicep->driverAt(index)) {
                 FileLine* const flp = nodep->fileline();
-                AstNodeDType* const dtypep = DfgGraph::toDfgDType(nodep->dtypep());
+                AstNodeDType* const dtypep = V3Dfg::toDfgDType(nodep->dtypep());
                 if (VN_IS(dtypep, BasicDType)) {
                     DfgSplicePacked* const newp = make<DfgSplicePacked>(flp, dtypep);
-                    AstNodeDType* const uaDtypep = DfgGraph::dtypeArray(dtypep, 1);
+                    AstNodeDType* const uaDtypep = V3Dfg::dtypeArray(dtypep, 1);
                     DfgUnitArray* const uap = make<DfgUnitArray>(flp, uaDtypep);
                     uap->srcp(newp);
-                    splicep->addDriver(flp, index, uap);
+                    splicep->addDriver(uap, index, flp);
                 } else if (VN_IS(dtypep, UnpackArrayDType)) {
                     DfgSpliceArray* const newp = make<DfgSpliceArray>(flp, dtypep);
-                    splicep->addDriver(flp, index, newp);
+                    splicep->addDriver(newp, index, flp);
                 } else {
                     nodep->v3fatalSrc("Unhandled AstNodeDType sub-type");  // LCOV_EXCL_LINE
                 }
@@ -267,64 +269,73 @@ class AstToDfgConverter final : public VNVisitor {
                 , m_rhsp{rhsp} {}
         };
 
+        // Simplify the LHS, to get rid of things like SEL(CONCAT(_, _), _)
+        lhsp = VN_AS(V3Const::constifyExpensiveEdit(lhsp), NodeExpr);
+
+        // Assigning compound expressions to a concatenated LHS requires a temporary
+        // to avoid multiple use of the expression
+        if (VN_IS(lhsp, Concat) && !vtxp->is<DfgVertexVar>() && !vtxp->is<DfgConst>()) {
+            const size_t n = ++m_nUnpack;
+            DfgVertexVar* const tmpp = createTmp(*m_logicp, flp, vtxp->dtypep(), "Unpack", n);
+            tmpp->srcp(vtxp);
+            vtxp = tmpp;
+        }
+
         // Convert each concatenation LHS separately, gather all assignments
         // we need to do into 'assignments', return true if all LValues
         // converted successfully.
         std::vector<Assignment> assignments;
-        const std::function<bool(AstNodeExpr*, DfgVertex*)> convertAllLValues
-            = [&](AstNodeExpr* lhsp, DfgVertex* vtxp) -> bool {
-            // Simplify the LHS, to get rid of things like SEL(CONCAT(_, _), _)
-            lhsp = VN_AS(V3Const::constifyExpensiveEdit(lhsp), NodeExpr);
-
-            // Concatenation on the LHS, convert each parts
-            if (AstConcat* const concatp = VN_CAST(lhsp, Concat)) {
-                AstNodeExpr* const cLhsp = concatp->lhsp();
+        const std::function<bool(AstNodeExpr*, uint32_t)> convertAllLValues
+            = [&](AstNodeExpr* subp, uint32_t lsb) -> bool {
+            // Concatenation on the LHS, convert each part
+            if (AstConcat* const concatp = VN_CAST(subp, Concat)) {
                 AstNodeExpr* const cRhsp = concatp->rhsp();
-                // Convert Left of concat
-                FileLine* const lFlp = cLhsp->fileline();
-                AstNodeDType* const lDtp = DfgGraph::toDfgDType(cLhsp->dtypep());
-                DfgSel* const lVtxp = make<DfgSel>(lFlp, lDtp);
-                lVtxp->fromp(vtxp);
-                lVtxp->lsb(cRhsp->width());
-                if (!convertAllLValues(cLhsp, lVtxp)) return false;
+                AstNodeExpr* const cLhsp = concatp->lhsp();
                 // Convert Rigth of concat
-                FileLine* const rFlp = cRhsp->fileline();
-                AstNodeDType* const rDtp = DfgGraph::toDfgDType(cRhsp->dtypep());
-                DfgSel* const rVtxp = make<DfgSel>(rFlp, rDtp);
-                rVtxp->fromp(vtxp);
-                rVtxp->lsb(0);
-                return convertAllLValues(cRhsp, rVtxp);
+                if (!convertAllLValues(cRhsp, lsb)) return false;
+                // Convert Left of concat
+                return convertAllLValues(cLhsp, lsb + cRhsp->width());
             }
 
             // Non-concatenation, convert the LValue
-            const auto pair = convertLValue(lhsp);
+            const auto pair = convertLValue(subp);
             if (!pair.first) return false;
-            assignments.emplace_back(pair.first, pair.second, vtxp);
+
+            // If whole lhs, just use it
+            if (subp == lhsp) {
+                assignments.emplace_back(pair.first, pair.second, vtxp);
+                return true;
+            }
+
+            // Otherwise select the relevant bits
+            DfgSel* const selp = make<DfgSel>(subp->fileline(), V3Dfg::toDfgDType(subp->dtypep()));
+            selp->fromp(vtxp);
+            selp->lsb(lsb);
+            assignments.emplace_back(pair.first, pair.second, selp);
             return true;
         };
 
         // Convert the given LHS assignment, give up if any LValues failed to convert
-        if (!convertAllLValues(lhsp, vtxp)) return false;
+        if (!convertAllLValues(lhsp, 0)) return false;
 
         // All successful, connect the drivers
         for (const Assignment& item : assignments) {
             if (DfgSplicePacked* const spp = item.m_lhsp->template cast<DfgSplicePacked>()) {
-                spp->addDriver(flp, item.m_idx, item.m_rhsp);
+                spp->addDriver(item.m_rhsp, item.m_idx, flp);
             } else if (DfgSpliceArray* const sap = item.m_lhsp->template cast<DfgSpliceArray>()) {
                 AstUnpackArrayDType* const lDtp = VN_AS(sap->dtypep(), UnpackArrayDType);
                 const AstNodeDType* const lEleDtp = lDtp->subDTypep();
                 AstNodeDType* const rDtp = item.m_rhsp->dtypep();
                 if (lEleDtp->isSame(rDtp)) {
                     // RHS is assigning an element of this array. Need a DfgUnitArray adapter.
-                    AstNodeDType* const uaDtp = DfgGraph::dtypeArray(rDtp, 1);
-                    DfgUnitArray* const uap = make<DfgUnitArray>(flp, uaDtp);
+                    DfgUnitArray* const uap = make<DfgUnitArray>(flp, V3Dfg::dtypeArray(rDtp, 1));
                     uap->srcp(item.m_rhsp);
-                    sap->addDriver(flp, item.m_idx, uap);
+                    sap->addDriver(uap, item.m_idx, flp);
                 } else {
                     // RHS is assigning an array (or array slice). Should be the same element type.
                     const AstNodeDType* const rEleDtp = VN_AS(rDtp, UnpackArrayDType)->subDTypep();
                     UASSERT_OBJ(lEleDtp->isSame(rEleDtp), item.m_rhsp, "Mismatched array types");
-                    sap->addDriver(flp, item.m_idx, item.m_rhsp);
+                    sap->addDriver(item.m_rhsp, item.m_idx, flp);
                 }
             } else {
                 item.m_lhsp->v3fatalSrc("Unhandled DfgVertexSplice sub-type");  // LCOV_EXCL_LINE
@@ -377,14 +388,14 @@ class AstToDfgConverter final : public VNVisitor {
         FileLine* const flp = nodep->fileline();
         DfgVertex* vtxp = nullptr;
         if (const AstConst* const constp = VN_CAST(nodep->lsbp(), Const)) {
-            DfgSel* const selp = make<DfgSel>(flp, DfgGraph::toDfgDType(nodep->dtypep()));
+            DfgSel* const selp = make<DfgSel>(flp, V3Dfg::toDfgDType(nodep->dtypep()));
             selp->fromp(nodep->fromp()->user2u().to<DfgVertex*>());
             selp->lsb(constp->toUInt());
             vtxp = selp;
         } else {
             iterate(nodep->lsbp());
             if (m_foundUnhandled) return;
-            DfgMux* const muxp = make<DfgMux>(flp, DfgGraph::toDfgDType(nodep->dtypep()));
+            DfgMux* const muxp = make<DfgMux>(flp, V3Dfg::toDfgDType(nodep->dtypep()));
             muxp->fromp(nodep->fromp()->user2u().to<DfgVertex*>());
             muxp->lsbp(nodep->lsbp()->user2u().to<DfgVertex*>());
             vtxp = muxp;
@@ -397,16 +408,26 @@ class AstToDfgConverter final : public VNVisitor {
 public:
     // PUBLIC METHODS
 
+    // Create temporay variable capable of holding the given type
+    DfgVertexVar* createTmp(DfgLogic& logic, FileLine* flp, AstNodeDType* dtypep,
+                            const std::string& prefix, size_t tmpCount) {
+        const std::string name = m_dfg.makeUniqueName(prefix, tmpCount);
+        DfgVertexVar* const vtxp = m_dfg.makeNewVar(flp, name, dtypep, logic.scopep());
+        logic.synth().emplace_back(vtxp);
+        vtxp->varp()->isInternal(true);
+        vtxp->tmpForp(vtxp->nodep());
+        return vtxp;
+    }
+
     // Create a new temporary variable capable of holding 'varp'
-    static DfgVertexVar* createTmp(DfgGraph& dfg, DfgLogic& logic, Variable* varp,
-                                   const std::string& prefix) {
+    DfgVertexVar* createTmp(DfgLogic& logic, Variable* varp, const std::string& prefix) {
         AstVar* const astVarp = T_Scoped ? reinterpret_cast<AstVarScope*>(varp)->varp()
                                          : reinterpret_cast<AstVar*>(varp);
         const std::string prfx = prefix + "_" + astVarp->name();
-        const std::string name = dfg.makeUniqueName(prfx, astVarp->user3Inc());
-        AstNodeDType* const dtypep = DfgGraph::toDfgDType(astVarp->dtypep());
-        AstScope* const scp = T_Scoped ? reinterpret_cast<AstVarScope*>(varp)->scopep() : nullptr;
-        DfgVertexVar* const vtxp = dfg.makeNewVar(astVarp->fileline(), name, dtypep, scp);
+        const std::string name = m_dfg.makeUniqueName(prfx, astVarp->user3Inc());
+        FileLine* const flp = astVarp->fileline();
+        AstNodeDType* const dtypep = V3Dfg::toDfgDType(astVarp->dtypep());
+        DfgVertexVar* const vtxp = m_dfg.makeNewVar(flp, name, dtypep, logic.scopep());
         logic.synth().emplace_back(vtxp);
         vtxp->varp()->isInternal(true);
         vtxp->tmpForp(varp);
@@ -429,7 +450,7 @@ class AstToDfgConverter final : public VNVisitor {
         AstNodeExpr* const lhsp = nodep->lhsp();
         AstNodeExpr* const rhsp = nodep->rhsp();
         // Check data types are compatible.
-        if (!DfgGraph::isSupported(lhsp->dtypep()) || !DfgGraph::isSupported(rhsp->dtypep())) {
+        if (!V3Dfg::isSupported(lhsp->dtypep()) || !V3Dfg::isSupported(rhsp->dtypep())) {
             ++m_ctx.m_conv.nonRepDType;
             return false;
         }
@@ -486,17 +507,17 @@ class AstToDfgSynthesize final {
 
     // Represents a [potentially partial] driver of a variable
     struct Driver final {
-        FileLine* m_flp = nullptr;  // Location of driver in source
+        DfgVertex* m_vtxp = nullptr;  // Driving vertex
         uint32_t m_lo = 0;  // Low index of driven range (internal, not Verilog)
         uint32_t m_hi = 0;  // High index of driven range (internal, not Verilog)
-        DfgVertex* m_vtxp = nullptr;  // Driving vertex
+        FileLine* m_flp = nullptr;  // Location of driver in source
 
         Driver() = default;
-        Driver(FileLine* flp, uint32_t lo, DfgVertex* vtxp)
-            : m_flp{flp}
+        Driver(DfgVertex* vtxp, uint32_t lo, FileLine* flp)
+            : m_vtxp{vtxp}
             , m_lo{lo}
             , m_hi{lo + vtxp->size() - 1}
-            , m_vtxp{vtxp} {}
+            , m_flp{flp} {}
         operator bool() const { return m_vtxp != nullptr; }
 
         bool operator<(const Driver& other) const {
@@ -512,13 +533,15 @@ class AstToDfgSynthesize final {
     DfgGraph& m_dfg;  // The graph being built
     V3DfgSynthesisContext& m_ctx;  // The context for stats
     AstToDfgConverter<T_Scoped> m_converter;  // The convert instance to use for each construct
+    size_t m_nBranchCond = 0;  // Sequence numbers for temporaries
+    size_t m_nPathPred = 0;  // Sequence numbers for temporaries
 
     // STATE - for current DfgLogic being synthesized
     DfgLogic* m_logicp = nullptr;  // Current logic vertex we are synthesizing
     CfgBlockMap<SymTab> m_bbToISymTab;  // Map from CfgBlock -> input symbol table
     CfgBlockMap<SymTab> m_bbToOSymTab;  // Map from CfgBlock -> output symbol table
-    CfgBlockMap<DfgVertex*> m_bbToCondp;  // Map from CfgBlock ->  terminating branch condition
-    CfgEdgeMap<DfgVertex*> m_edgeToPredicatep;  // Map CfgGraphEdge -> path predicate to get there
+    CfgBlockMap<DfgVertexVar*> m_bbToCondp;  // Map from CfgBlock ->  terminating branch condition
+    CfgEdgeMap<DfgVertexVar*> m_edgeToPredicatep;  // Map CfgGraphEdge -> path predicate to there
     CfgDominatorTree m_domTree;  // The dominator tree of the current CFG
 
     // STATE - Some debug aid
@@ -536,8 +559,9 @@ class AstToDfgSynthesize final {
         // If we have the debugged logic, compute the vertices feeding its outputs
         if (VL_UNLIKELY(m_debugLogicp)) {
             std::vector<const DfgVertex*> outputs;
-            m_debugLogicp->forEachSink([&outputs](const DfgVertex& v) {  //
+            m_debugLogicp->foreachSink([&outputs](const DfgVertex& v) {
                 outputs.emplace_back(v.singleSink()->as<DfgVertexVar>());
+                return false;
             });
             m_debugOSrcConep = m_dfg.sourceCone(outputs);
         }
@@ -574,65 +598,58 @@ class AstToDfgSynthesize final {
     }
 
     // Gather all drivers of a resolved variable
-    static std::pair<std::vector<Driver>, DfgVertex*> gatherDrivers(const DfgVertexSplice* vtxp) {
+    static std::vector<Driver> gatherDrivers(DfgVertexSplice* vtxp) {
         // Collect them all, check if they are sorted
         std::vector<Driver> drivers;
-        drivers.reserve(vtxp->arity());
-        DfgVertex* const defaultp = vtxp->defaultp();
+        drivers.reserve(vtxp->nInputs());
         bool sorted = true;
-        vtxp->forEachSourceEdge([&](const DfgEdge& edge, size_t i) {
-            DfgVertex* const driverp = edge.sourcep();
-            UASSERT_OBJ(driverp, vtxp, "Should not have created undriven sources");
-            // Ignore default driver
-            if (driverp == defaultp) return;
+        vtxp->foreachDriver([&](DfgVertex& src, uint32_t lo, FileLine* flp) {
             // Collect the driver
-            drivers.emplace_back(vtxp->driverFileLine(i), vtxp->driverLo(i), driverp);
+            drivers.emplace_back(&src, lo, flp);
             // Check if drivers are sorted - most often they are
             const size_t n = drivers.size();
             if (n >= 2 && drivers[n - 1] < drivers[n - 2]) sorted = false;
+            return false;
         });
 
         // Sort if unsorted
         if (!sorted) std::stable_sort(drivers.begin(), drivers.end());
 
         // Done
-        return {std::move(drivers), defaultp};
+        return drivers;
     }
 
     // Gather all synthesized drivers of an unresolved variable
-    static std::vector<Driver> gatherDriversUnresolved(const DfgUnresolved* vtxp) {
+    static std::vector<Driver> gatherDriversUnresolved(DfgUnresolved* vtxp) {
         std::vector<Driver> drivers;
-        drivers.reserve(vtxp->arity());
+        drivers.reserve(vtxp->nInputs());
 
         // For better locations in error reporting, we unpick concatenations
         // which are sometimes introduced by combinint assignments in V3Const.
-        const std::function<void(FileLine*, uint32_t, DfgVertex*)> gather
-            = [&](FileLine* flp, uint32_t lo, DfgVertex* vtxp) -> void {
+        const std::function<void(DfgVertex*, uint32_t, FileLine*)> gather
+            = [&](DfgVertex* vtxp, uint32_t lo, FileLine* flp) -> void {
             if (DfgConcat* const concatp = vtxp->cast<DfgConcat>()) {
                 DfgVertex* const rhsp = concatp->rhsp();
-                gather(rhsp->fileline(), lo, rhsp);
+                gather(rhsp, lo, rhsp->fileline());
                 DfgVertex* const lhsp = concatp->lhsp();
-                gather(lhsp->fileline(), lo + rhsp->width(), lhsp);
+                gather(lhsp, lo + rhsp->width(), lhsp->fileline());
                 return;
             }
-            drivers.emplace_back(flp, lo, vtxp);
+            drivers.emplace_back(vtxp, lo, flp);
         };
 
         // Gather all synthesized drivers
-        vtxp->forEachSource([&](const DfgVertex& src) {
+        vtxp->foreachSource([&](DfgVertex& src) {
             // Can ignore the original DfgLogic
-            if (src.is<DfgLogic>()) return;
-
+            if (src.is<DfgLogic>()) return false;
             // Synthesized drivers must be a splice at this point
-            const DfgVertexSplice* const splicep = src.as<DfgVertexSplice>();
-            splicep->forEachSourceEdge([&](const DfgEdge& edge, size_t i) {
-                DfgVertex* const driverp = edge.sourcep();
-                UASSERT_OBJ(driverp, splicep, "Should not have created undriven sources");
-                // Ignore the default driver, it's the feedback in circular logic
-                if (driverp == splicep->defaultp()) return;
-                // Collect the driver
-                gather(splicep->driverFileLine(i), splicep->driverLo(i), driverp);
+            DfgVertexSplice* const splicep = src.as<DfgVertexSplice>();
+            // Collect the driver
+            splicep->foreachDriver([&](DfgVertex& src, uint32_t lo, FileLine* flp) {
+                gather(&src, lo, flp);
+                return false;
             });
+            return false;
         });
 
         // Sort the drivers
@@ -657,23 +674,16 @@ class AstToDfgSynthesize final {
         const DfgUnitArray* const bUap = b.m_vtxp->template cast<DfgUnitArray>();
         if (!bUap) return {false, false};
         // ... and are themeselves partial
-        const DfgSplicePacked* const aSp = aUap->srcp()->template cast<DfgSplicePacked>();
+        DfgSplicePacked* const aSp = aUap->srcp()->template cast<DfgSplicePacked>();
         if (!aSp) return {false, false};
-        const DfgSplicePacked* const bSp = bUap->srcp()->template cast<DfgSplicePacked>();
+        DfgSplicePacked* const bSp = bUap->srcp()->template cast<DfgSplicePacked>();
         if (!bSp) return {false, false};
         UASSERT_OBJ(aSp->dtypep()->isSame(bSp->dtypep()), &var, "DTypes should match");
 
         // Gather drivers of a
-        std::vector<Driver> aDrivers;
-        DfgVertex* aDefaultp = nullptr;
-        std::tie(aDrivers, aDefaultp) = gatherDrivers(aSp);
-        UASSERT_OBJ(!aDefaultp, aSp, "Should not have default driver here");
-
+        std::vector<Driver> aDrivers = gatherDrivers(aSp);
         // Gather drivers of b
-        std::vector<Driver> bDrivers;
-        DfgVertex* bDefaultp = nullptr;
-        std::tie(bDrivers, bDefaultp) = gatherDrivers(bSp);
-        UASSERT_OBJ(!bDefaultp, bSp, "Should not have default driver here");
+        std::vector<Driver> bDrivers = gatherDrivers(bSp);
 
         // Merge them
         std::vector<Driver> abDrivers;
@@ -692,7 +702,7 @@ class AstToDfgSynthesize final {
         // Successfully resolved. Needs a new splice and unit.
         FileLine* const flp = var.fileline();
         DfgSplicePacked* const splicep = make<DfgSplicePacked>(flp, aSp->dtypep());
-        for (const Driver& d : abDrivers) splicep->addDriver(d.m_flp, d.m_lo, d.m_vtxp);
+        for (const Driver& d : abDrivers) splicep->addDriver(d.m_vtxp, d.m_lo, d.m_flp);
         DfgUnitArray* const uap = make<DfgUnitArray>(flp, aUap->dtypep());
         uap->srcp(splicep);
         a.m_vtxp = uap;
@@ -830,7 +840,7 @@ class AstToDfgSynthesize final {
             }
 
             // Coalesce Adjacent ranges,
-            const auto dtypep = DfgGraph::dtypePacked(iD.m_vtxp->width() + jD.m_vtxp->width());
+            const auto dtypep = V3Dfg::dtypePacked(iD.m_vtxp->width() + jD.m_vtxp->width());
             DfgConcat* const concatp = make<DfgConcat>(iD.m_flp, dtypep);
             concatp->rhsp(iD.m_vtxp);
             concatp->lhsp(jD.m_vtxp);
@@ -857,7 +867,7 @@ class AstToDfgSynthesize final {
         } else {
             var.v3fatalSrc("Unhandled DfgVertexVar sub-type");  // LCOV_EXCL_LINE
         }
-        for (const Driver& d : newDrivers) splicep->addDriver(d.m_flp, d.m_lo, d.m_vtxp);
+        for (const Driver& d : newDrivers) splicep->addDriver(d.m_vtxp, d.m_lo, d.m_flp);
         return splicep;
     }
 
@@ -865,7 +875,7 @@ class AstToDfgSynthesize final {
     // we generally cannot synthesize the construct, as we will likely need to
     // introduce intermediate values that would not be updated.
     static bool hasExternallyWrittenVariable(DfgLogic& vtx) {
-        return vtx.findSink<DfgVertex>([](const DfgVertex& sink) -> bool {
+        return vtx.foreachSink([&](const DfgVertex& sink) {
             // 'sink' is a splice (for which 'vtxp' is an unresolved driver),
             // which drives the target variable.
             const DfgVertexVar* varp = sink.singleSink()->as<DfgVertexVar>();
@@ -879,18 +889,17 @@ class AstToDfgSynthesize final {
 
     // Initialzie input symbol table of entry CfgBlock
     void initializeEntrySymbolTable(SymTab& iSymTab) {
-        m_logicp->forEachSource([&](DfgVertex& src) {
+        m_logicp->foreachSource([&](DfgVertex& src) {
             DfgVertexVar* const vvp = src.as<DfgVertexVar>();
             Variable* const varp = reinterpret_cast<Variable*>(vvp->nodep());
             iSymTab[varp] = vvp;
+            return false;
         });
     }
 
     // Join variable drivers across a control flow confluence (insert muxes ...)
-    DfgVertexVar* joinDrivers(Variable* varp, DfgVertex* predicatep,  //
+    DfgVertexVar* joinDrivers(Variable* varp, DfgVertexVar* predicatep,  //
                               DfgVertexVar* thenp, DfgVertexVar* elsep) {
-        UASSERT_OBJ(!predicatep->is<DfgConst>(), predicatep, "joinDrivers with cons predicate");
-
         AstNode* const thenVarp = thenp->tmpForp() ? thenp->tmpForp() : thenp->nodep();
         AstNode* const elseVarp = elsep->tmpForp() ? elsep->tmpForp() : elsep->nodep();
         UASSERT_OBJ(thenVarp == elseVarp, varp, "Attempting to join unrelated variables");
@@ -916,14 +925,12 @@ class AstToDfgSynthesize final {
         }
 
         // Gather drivers of 'thenp' - only if 'thenp' is not an input to the synthesized block
-        std::vector<Driver> tDrivers;
-        DfgVertex* tDefaultp = nullptr;
-        std::tie(tDrivers, tDefaultp) = gatherDrivers(thenp->srcp()->as<DfgVertexSplice>());
+        DfgVertex* const tDefaultp = thenp->defaultp();
+        std::vector<Driver> tDrivers = gatherDrivers(thenp->srcp()->as<DfgVertexSplice>());
 
         // Gather drivers of 'elsep' - only if 'thenp' is not an input to the synthesized block
-        std::vector<Driver> eDrivers;
-        DfgVertex* eDefaultp = nullptr;
-        std::tie(eDrivers, eDefaultp) = gatherDrivers(elsep->srcp()->as<DfgVertexSplice>());
+        DfgVertex* const eDefaultp = elsep->defaultp();
+        std::vector<Driver> eDrivers = gatherDrivers(elsep->srcp()->as<DfgVertexSplice>());
 
         // Default drivers should be the same or not present on either
         UASSERT_OBJ(tDefaultp == eDefaultp, varp, "Different default drivers");
@@ -932,7 +939,7 @@ class AstToDfgSynthesize final {
         FileLine* const flp = predicatep->fileline();
 
         // Create a fresh temporary for the joined value
-        DfgVertexVar* const joinp = m_converter.createTmp(m_dfg, *m_logicp, varp, "SynthJoin");
+        DfgVertexVar* const joinp = m_converter.createTmp(*m_logicp, varp, "SynthJoin");
         DfgVertexSplice* const joinSplicep = make<DfgSplicePacked>(flp, joinp->dtypep());
         joinp->srcp(joinSplicep);
 
@@ -949,7 +956,7 @@ class AstToDfgSynthesize final {
             condp->condp(predicatep);
             condp->thenp(thenp);
             condp->elsep(elsep);
-            joinSplicep->addDriver(tDrivers[0].m_flp, 0, condp);
+            joinSplicep->addDriver(condp, 0, tDrivers[0].m_flp);
 
             // Done
             return joinp;
@@ -972,7 +979,7 @@ class AstToDfgSynthesize final {
                 return nullptr;
             }
 
-            AstNodeDType* const dtypep = DfgGraph::dtypePacked(tDriver.m_hi - tDriver.m_lo + 1);
+            AstNodeDType* const dtypep = V3Dfg::dtypePacked(tDriver.m_hi - tDriver.m_lo + 1);
             DfgCond* const condp = make<DfgCond>(flp, dtypep);
             condp->condp(predicatep);
 
@@ -989,18 +996,18 @@ class AstToDfgSynthesize final {
             condp->elsep(elseSelp);
 
             // Add it as a driver to the join
-            joinSplicep->addDriver(tDriver.m_flp, tDriver.m_lo, condp);
+            joinSplicep->addDriver(condp, tDriver.m_lo, tDriver.m_flp);
         }
 
         // If there was a default driver, add it to te join
-        if (tDefaultp) joinSplicep->defaultp(tDefaultp);
+        if (tDefaultp) joinp->defaultp(tDefaultp);
 
         // Done
         return joinp;
     }
 
     // Merge 'thenSymTab' into 'elseSymTab' using the given predicate to join values
-    bool joinSymbolTables(SymTab& elseSymTab, DfgVertex* predicatep, const SymTab& thenSymTab) {
+    bool joinSymbolTables(SymTab& elseSymTab, DfgVertexVar* predicatep, const SymTab& thenSymTab) {
         // Give up if something is not assigned on all paths ... Latch?
         if (thenSymTab.size() != elseSymTab.size()) {
             ++m_ctx.m_synt.nonSynLatch;
@@ -1029,7 +1036,7 @@ class AstToDfgSynthesize final {
 
     // Given two joining control flow edges, compute how to join their symbols.
     // Returns the predicaete to join over, and the 'then' and 'else' blocks.
-    std::tuple<DfgVertex*, const CfgBlock*, const CfgBlock*>  //
+    std::tuple<DfgVertexVar*, const CfgBlock*, const CfgBlock*>  //
     howToJoin(const CfgEdge* const ap, const CfgEdge* const bp) {
         // Find the closest common dominator of the two paths
         const CfgBlock* const domp = m_domTree.closestCommonDominator(ap->srcp(), bp->srcp());
@@ -1096,7 +1103,7 @@ class AstToDfgSynthesize final {
 
         // We also have a simpler job if there are 2 predecessors
         if (bb.isTwoWayJoin()) {
-            DfgVertex* predicatep = nullptr;
+            DfgVertexVar* predicatep = nullptr;
             const CfgBlock* thenp = nullptr;
             const CfgBlock* elsep = nullptr;
             std::tie(predicatep, thenp, elsep)
@@ -1112,10 +1119,10 @@ class AstToDfgSynthesize final {
         // Gather predecessors
         struct Predecessor final {
             const CfgBlock* m_bbp;  // Predeccessor block
-            DfgVertex* m_predicatep;  // Predicate predecessor reached this block with
+            DfgVertexVar* m_predicatep;  // Predicate predecessor reached this block with
             const SymTab* m_oSymTabp;  // Output symbol table or predecessor
             Predecessor() = delete;
-            Predecessor(const CfgBlock* bbp, DfgVertex* predicatep, const SymTab* oSymTabp)
+            Predecessor(const CfgBlock* bbp, DfgVertexVar* predicatep, const SymTab* oSymTabp)
                 : m_bbp{bbp}
                 , m_predicatep{predicatep}
                 , m_oSymTabp{oSymTabp} {}
@@ -1126,7 +1133,7 @@ class AstToDfgSynthesize final {
             for (const V3GraphEdge& edge : bb.inEdges()) {
                 const CfgEdge& cfgEdge = static_cast<const CfgEdge&>(edge);
                 const CfgBlock* const predecessorp = cfgEdge.srcp();
-                DfgVertex* const predicatep = m_edgeToPredicatep[cfgEdge];
+                DfgVertexVar* const predicatep = m_edgeToPredicatep[cfgEdge];
                 const SymTab* const oSymTabp = &m_bbToOSymTab[predecessorp];
                 res.emplace_back(predecessorp, predicatep, oSymTabp);
             }
@@ -1142,7 +1149,7 @@ class AstToDfgSynthesize final {
         joined = *predecessors[0].m_oSymTabp;
         // Join over all other predecessors
         for (size_t i = 1; i < predecessors.size(); ++i) {
-            DfgVertex* const predicatep = predecessors[i].m_predicatep;
+            DfgVertexVar* const predicatep = predecessors[i].m_predicatep;
             const SymTab& oSymTab = *predecessors[i].m_oSymTabp;
             if (!joinSymbolTables(joined, predicatep, oSymTab)) return false;
         }
